from cb.sensor.NewRegistrationCallback import NewRegistrationCallback
from cb.db.core_models import SensorMergedView


class DefaultNewRegistrationCallback (NewRegistrationCallback):

    @staticmethod
    def get_sensor_id(db_session, sensor_reg_request, logger):
        sensor_host_name = sensor_reg_request.ComputerId.ComputerName
        sensor_dns_name = sensor_reg_request.ComputerId.ComputerDnsName

        sensor = db_session.query(SensorMergedView) \
            .filter(SensorMergedView.computer_name == sensor_host_name) \
            .filter(SensorMergedView.computer_dns_name == sensor_dns_name) \
            .order_by(SensorMergedView.last_checkin_time.desc()) \
            .first()

        if sensor is not None:
            logger.debug("Found sensor id [%d] for hostname [%s @ %s]" % (sensor.id, sensor_host_name, sensor_dns_name))
            return sensor.id
        else:
            logger.debug("Could not find a sensor id for hostname [%s @ %s]" %
                         (sensor_host_name, sensor_dns_name))
            return 0
