import logging

_logger = logging.getLogger(__name__)

'''
A method must exist in your plugin script that is named "authenticate" and takes all 6 arguments.
The arguments are explained below:
    user_id         integer     the id of the user making the request (from the CB postgres database record)
    user_name       string      the username of the user making the request
    path            string      the server-relative URI path for the request (e.g.- "/api/info")
    method          string      the HTTP verb used for the request (GET, POST, etc)
    api_token       bool        whether the use is authenticating with an api token or not (if False, the user is
                                using performing interactive authentication with the UI)
    requesting_ip   string      A CSV of the X-Forwarded-For ip addresses.  The originating ip should be the leftmost.
                                In cases where a proxy is not used, there should just be one address (without a
                                trailing comma).
                                This address can be either an ipv4 or ipv6 address, depending on proxy and VMware Carbon
                                Black EDR Server network configurations.

A return value of True will authenticate the request.
A return value of False will deny the request.
'''


def authenticate(user_id, user_name, path, method, api_token, requesting_ip):
    _logger.info('Received 2FA request for user_id: %s, user_name: %s, path: %s, method: %s, '
                 'api_token: %s, requesting_ip: %s ' %
                 (user_id, user_name, path, method, api_token, requesting_ip))
    return True
